%This function is the main function.
%The aim of this function is to compare the redesigned auction algorithm
%AB1 and the conventional auction algorithm AB2.
clc
clear

Nw=120;  %Number of weapons
Nt=110;  %Number of targets

test_count=0;
test_all=1;
fx_data=zeros(test_all,50); 
fx1_data=zeros(test_all,50);
sum_data=zeros(test_all,50); 
sum1_data=zeros(test_all,50);
runtime_data=zeros(test_all,50);
runtime1_data=zeros(test_all,50);
round0=zeros(test_all,1);
round1=zeros(test_all,1);
dam_val0=zeros(test_all,1);
dam_val1=zeros(test_all,1);
ttoal0=zeros(test_all,1);
ttoal1=zeros(test_all,1);

while test_count<test_all
    test_count=test_count+1;
neighbor=ones(Nw,Nt);
Aij0=rand(Nw,Nt); 
%%%AB1
[Jt_primal,fx,sum0,runtime]=AB1(Aij0,neighbor);
%%%AB2
[Jt_primal1,fx1,sum1,runtime1]=AB2(Aij0,neighbor);

round0(test_count)=length(fx);
dam_val0(test_count)=fx(round0(test_count));
round1(test_count)=length(fx1);
dam_val1(test_count)=fx1(round1(test_count));
ttoal0(test_count)=sum(runtime(1:round0(test_count)-1));
ttoal1(test_count)=sum(runtime1(1:round1(test_count)-1));

if ~isempty(fx)
    if length(fx)<50
        fx_data(test_count,1:length(fx))=fx;
        fx_data(test_count,(length(fx)+1):50)=fx(length(fx))*ones(1,50-length(fx));
    else
        fx_data(test_count,:)=fx(1:50);
    end   
end

if ~isempty(sum0)
    if length(sum0)<50
        sum_data(test_count,1:length(sum0))=sum0;
        sum_data(test_count,(length(sum0)+1):50)=sum0(length(sum0))*ones(1,50-length(sum0));
    else
        sum_data(test_count,:)=sum0(1:50);
    end   
end

if ~isempty(fx1)
    if length(fx1)<50
        fx1_data(test_count,1:length(fx1))=fx1;
        fx1_data(test_count,(length(fx1)+1):50)=fx1(length(fx1))*ones(1,50-length(fx1));
    else
        fx1_data(test_count,:)=fx1(1:50);
    end   
end

if ~isempty(sum1)
    if length(sum1)<50
        sum1_data(test_count,1:length(sum1))=sum1;
        sum1_data(test_count,(length(sum1)+1):50)=sum1(length(sum1))*ones(1,50-length(sum1));
    else
        sum1_data(test_count,:)=sum1(1:50);
    end   
end

if ~isempty(runtime)
    if length(runtime)<50
        runtime_data(test_count,1:length(runtime))=runtime;
        runtime_data(test_count,(length(runtime)+1):50)=runtime(length(runtime))*ones(1,50-length(runtime));
    else
        runtime_data(test_count,:)=runtime(1:50);
    end   
end

if ~isempty(runtime1)
    if length(runtime1)<50
        runtime1_data(test_count,1:length(runtime1))=runtime1;
        runtime1_data(test_count,(length(runtime1)+1):50)=runtime1(length(runtime1))*ones(1,50-length(runtime1));
    else
        runtime1_data(test_count,:)=runtime1(1:50);
    end   
end
end

% save fx_data.txt -ascii fx_data
% save sum.txt -ascii sum_data
% save fx1_data.txt -ascii fx1_data
% save sum1.txt -ascii sum1_data
% save runtime_data.txt -ascii runtime_data
% save runtime1_data.txt -ascii runtime1_data
% save round0.txt -ascii round0
% save round1.txt -ascii round1
% save Aij.txt -ascii Aij0

fx_mean=mean(fx_data,1);
fx_var=var(fx_data,1,1);
sum_mean=mean(sum_data,1);
sum_var=var(sum_data,1,1);
fx1_mean=mean(fx1_data,1);
fx1_var=var(fx1_data,1,1);
sum1_mean=mean(sum1_data,1);
sum1_var=var(sum1_data,1,1);
runtime_mean=mean(runtime_data,1);
runtime1_mean=mean(runtime1_data,1);
rn=mean(round0);
rn1=mean(round1);

%the data is shown in Table 1 in our manuscript
rf0=mean(dam_val0);
rt0=mean(ttoal0);
rf1=mean(dam_val1);
rt1=mean(ttoal1);
rf0_var=var(dam_val0);
rt0_var=var(ttoal0);
rf1_var=var(dam_val1);
rt1_var=var(ttoal1);

result_data=[rf0,rt0,rf1,rt1,rf0_var,rt0_var,rf1_var,rt1_var];
% save result_data.txt -ascii result_data

%plot
linewidth=2;
fontsize=20;
t=1:round(runtime_mean(1)*1000);
y=fx_mean(1)*ones(1,length(t));
for i=2:rn
    t_temp1=length(t);
    t_temp2=t_temp1+round(runtime_mean(i)*1000);
    t=[t,t_temp1+1:t_temp2];
    y=[y,fx_mean(i)*ones(1,round(runtime_mean(i)*1000))];
end
plot(t/1000,y,'k-','LineWidth',linewidth)
hold on
grid on
t1=1:round(runtime1_mean(1)*1000);
y1=fx1_mean(1)*ones(1,length(t1));
for i=2:rn1
    t_temp1=length(t1);
    t_temp2=t_temp1+round(runtime1_mean(i)*1000);
    t1=[t1,t_temp1+1:t_temp2];
    y1=[y1,fx1_mean(i)*ones(1,round(runtime1_mean(i)*1000))];
end
plot(t1/1000,y1,'r--','LineWidth',linewidth)
legend('AB1','AB2')
set(gca,'FontName','Times New Roman','fontsize',fontsize)
xlabel('Time (Sec.)','FontName','Times New Roman','fontsize',fontsize)
ylabel('Damage Value','FontName','Times New Roman','fontsize',fontsize)
% print -dtiff -r300 fig_10

