%This is the main function.
%The aim is to compare the three task swap algorithms: the proposed DWLLC
%algorithm, the Dijkstra algorithm, the BFS algorithm
clc
clear

M=120;
N=110;
test_count=0;
test_all=1;
loop_limit=280;

fx_my_data=zeros(test_all,loop_limit);
time_my_data=zeros(test_all,loop_limit);

fx_D_data=zeros(test_all,loop_limit);
time_D_data=zeros(test_all,loop_limit);

fx_BFS_data=zeros(test_all,loop_limit);
time_BFS_data=zeros(test_all,loop_limit);

round1=zeros(test_all,1);
round2=zeros(test_all,1);
round3=zeros(test_all,1);
round4=zeros(test_all,1);

tl1=1e-3;
tl2=0.02*M/120;

dam_val1=zeros(test_all,1);
dam_val2=zeros(test_all,1);
dam_val3=zeros(test_all,1);
ttoal1=zeros(test_all,1);
ttoal2=zeros(test_all,1);
ttoal3=zeros(test_all,1);

while test_count<test_all
    test_count=test_count+1;
    Aij0=rand(M,N);
    ri_tj_primal=[];
    for i=1:ceil(M/N)
        if i<ceil(M/N)
            ri_tj_primal=[ri_tj_primal,1:N];
        else
            ri_tj_primal=[ri_tj_primal,1:M-(i-1)*N];
        end
    end
    ri_tj0=1:M;
    cij=zeros(M,M);
    for i=1:M
        for j=1:M
            cij(i,j)=Aij0(i,ri_tj_primal(j));
        end
    end
    cij=1-cij; %transfer from the kill probability to the survival probability
    %calculate the survival probability of the target
    T_sur=ones(1,N);  
    for i=1:M
        T_sur(ri_tj_primal(ri_tj0(i)))=T_sur(ri_tj_primal(ri_tj0(i)))*cij(i,ri_tj0(i));
    end
    T_kill=1-T_sur;
    P_kill0=0;
    for i=1:N
        P_kill0=P_kill0+T_kill(i);
    end
    %DWLCC
    flag1=0;
    count_my1=1;
    loop1=loop_limit;   
    sum_my=[];
    fx_my=[];
    time_my=[];
    ri_tj_my=ri_tj0;
    P_kill_my0=P_kill0;
    temp_count=0;
    rd1=0;
    while flag1==0 && loop1>0
        loop1=loop1-1;
        t1=clock;
        [count_my,ri_tj_my1,flag1,sum_cost_primal,sum_cost_after,P_kill_my1]=mymethod(M,M,cij,ri_tj_my,ri_tj_primal,P_kill_my0);
        t2=clock;
        time_temp=etime(t2,t1);
        if time_temp<tl1
            time_temp=tl2;
        end
        if P_kill_my1-P_kill_my0==0
            temp_count=temp_count+1;
        end
        if temp_count<=2
            rd1=loop_limit-loop1;
        end
        if flag1
            fx_my=[fx_my,P_kill_my1];
            time_my=[time_my,time_temp];
            break;
        end          
        fx_my=[fx_my,P_kill_my0];
        time_my=[time_my,time_temp];
        ri_tj_my=ri_tj_my1;
        P_kill_my0=P_kill_my1;
        count_my1=count_my;
    end
    round1(test_count)=length(fx_my);
    dam_val1(test_count)=fx_my(round1(test_count));
    ttoal1(test_count)=sum(time_my(1:rd1-1));
    
    %Dijkstra
    fx_D=[];
    flag1=0;
    loop1=loop_limit;
    count_D1=1;
    sum_D=[];
    time_D=[];
    ri_tj_D=ri_tj0;
    P_kill_D0=P_kill0;
    temp_count=0;
    rd2=0;
    while flag1==0 && loop1>0
        loop1=loop1-1; 
        t1=clock;
        [count_D,ri_tj_D1,flag1,sum_cost_primal,sum_cost_after,P_kill_D1]=relaxation(M,M,cij,ri_tj_D,ri_tj_primal,P_kill_D0);
        t2=clock;
        time_temp=etime(t2,t1); 
        if time_temp<tl1
            time_temp=tl2;
        end
        if P_kill_D1-P_kill_D0==0
            temp_count=temp_count+1;
        end
        if temp_count<=2
            rd2=loop_limit-loop1;
        end
        if flag1
            fx_temp=P_kill_D0;
            fx_D=[fx_D,fx_temp];
            time_D=[time_D,time_temp];
            break;
        end         
        fx_temp=P_kill_D0;
        fx_D=[fx_D,fx_temp];  
        time_D=[time_D,time_temp];
        ri_tj_D=ri_tj_D1;
        P_kill_D0=P_kill_D1;
        count_D1=count_D;
    end
    round2(test_count)=length(fx_D);
    dam_val2(test_count)=fx_D(round2(test_count));
    ttoal2(test_count)=sum(time_D(1:rd2-1));
    
    %%%BFS
    fx_BFS=[];
    flag1=0;
    loop1=loop_limit;
    count_BFS1=1;
    sum_BFS=[];
    time_BFS=[];
    ri_tj1=ri_tj0;
    P_kill_BFS0=P_kill0;
    temp_count=0;
    while flag1==0 && loop1>0
        loop1=loop1-1; 
        
        t1=clock;
        [count_BFS,ri_tj_BFS,flag1,sum_cost_primal,sum_cost_after,P_kill_BFS1]=BFS(M,M,cij,ri_tj1,ri_tj_primal,P_kill_BFS0);
        t2=clock;
        time_temp=etime(t2,t1);
        if time_temp<tl1
            time_temp=tl2;
        end
        if P_kill_BFS1-P_kill_BFS0==0
            temp_count=temp_count+1;
        end
        
        if temp_count<=2
            round4(test_count)=loop_limit-loop1;
        end
        if flag1
            fx_temp=P_kill_BFS0;
            fx_BFS=[fx_BFS,fx_temp];
            time_BFS=[time_BFS,time_temp];
            break;
        end         
        fx_temp=P_kill_BFS0;
        fx_BFS=[fx_BFS,fx_temp];
        time_BFS=[time_BFS,time_temp];
        ri_tj1=ri_tj_BFS;      
        P_kill_BFS0=P_kill_BFS1;
        count_BFS1=count_BFS;
    end
    round3(test_count)=loop_limit-loop1;
    dam_val3(test_count)=fx_BFS(round3(test_count));
    ttoal3(test_count)=sum(time_BFS(1:round4(test_count)-1));
    
    if ~isempty(fx_my)
    if length(fx_my)<loop_limit
        fx_my_data(test_count,1:length(fx_my))=fx_my;
        fx_my_data(test_count,(length(fx_my)+1):loop_limit)=fx_my(length(fx_my))*ones(1,loop_limit-length(fx_my));
    else
        fx_my_data(test_count,:)=fx_my(1:loop_limit);
    end
    end
    if ~isempty(time_my)
    if length(time_my)<loop_limit
        time_my_data(test_count,1:length(time_my))=time_my;
        time_my_data(test_count,(length(time_my)+1):loop_limit)=time_my(length(time_my))*ones(1,loop_limit-length(time_my));
    else
        time_my_data(test_count,:)=time_my(1:loop_limit);
    end
    end

    
    if ~isempty(fx_D)
    if length(fx_D)<loop_limit
        fx_D_data(test_count,1:length(fx_D))=fx_D;
        fx_D_data(test_count,(length(fx_D)+1):loop_limit)=fx_D(length(fx_D))*ones(1,loop_limit-length(fx_D));
    else
        fx_D_data(test_count,:)=fx_D(1:loop_limit);
    end
    end
    if ~isempty(time_D)
    if length(time_D)<loop_limit
        time_D_data(test_count,1:length(time_D))=time_D;
        time_D_data(test_count,(length(time_D)+1):loop_limit)=time_D(length(time_D))*ones(1,loop_limit-length(time_D));
    else
        time_D_data(test_count,:)=time_D(1:loop_limit);
    end
    end
    
    
    if ~isempty(fx_BFS)
    if length(fx_BFS)<loop_limit
        fx_BFS_data(test_count,1:length(fx_BFS))=fx_BFS;
        fx_BFS_data(test_count,(length(fx_BFS)+1):loop_limit)=fx_BFS(length(fx_BFS))*ones(1,loop_limit-length(fx_BFS));
    else
        fx_BFS_data(test_count,:)=fx_BFS(1:loop_limit);
    end
    end
    if ~isempty(time_BFS)
    if length(time_BFS)<loop_limit
        time_BFS_data(test_count,1:length(time_BFS))=time_BFS;
        time_BFS_data(test_count,(length(time_BFS)+1):loop_limit)=time_BFS(length(time_BFS))*ones(1,loop_limit-length(time_BFS));
    else
        time_BFS_data(test_count,:)=time_BFS(1:loop_limit);
    end
    end
    
end
% save fx_my_data.txt -ascii fx_my_data
% save time_my_data.txt -ascii time_my_data
% save fx_D_data.txt -ascii fx_D_data
% save time_D_data.txt -ascii time_D_data
% save fx_BFS_data.txt -ascii fx_BFS_data
% save time_BFS_data.txt -ascii time_BFS_data
% save round1.txt -ascii round1
% save round2.txt -ascii round2
% save round3.txt -ascii round3
% save round4.txt -ascii round4

fx_my_mean=mean(fx_my_data,1);
t_my_mean=mean(time_my_data,1);
fx_D_mean=mean(fx_D_data,1);
t_D_mean=mean(time_D_data,1);
fx_BFS_mean=mean(fx_BFS_data,1);
t_BFS_mean=mean(time_BFS_data,1);

rn1=mean(round1);
rn2=mean(round2);
rn3=mean(round3);
rn4=mean(round4);

%the mean and the var for recording
rf1=mean(dam_val1);
rt1=mean(ttoal1);
rf2=mean(dam_val2);
rt2=mean(ttoal2);
rf3=mean(dam_val3);
rt3=mean(ttoal3);
rf1_var=std(dam_val1,1);
rt1_var=std(ttoal1,1);
rf2_var=std(dam_val2,1);
rt2_var=std(ttoal2,1);
rf3_var=std(dam_val3,1);
rt3_var=std(ttoal3,1);
result_data=[rf1,rt1,rf2,rt2,rf3,rt3,rf1_var,rt1_var,rf2_var,rt2_var,rf3_var,rt3_var];
% save result_data.txt -ascii result_data

%%%plot
linewidth=2;
fontsize=18;
t_limit=10*1000;
t1=1:round(t_my_mean(1)*1000);
y1=fx_my_mean(1)*ones(1,length(t1));
for i=2:rn1
    t_temp1=length(t1);
    t_temp2=t_temp1+round(t_my_mean(i)*1000);
    t1=[t1,t_temp1+1:t_temp2];
    y1=[y1,fx_my_mean(i)*ones(1,round(t_my_mean(i)*1000))];
end
if(t1<t_limit)
    plot(t1/1000,y1,'k-','LineWidth',linewidth)
else
    plot(t1(1:t_limit)/1000,y1(1:t_limit),'k-','LineWidth',linewidth)
end

hold on
grid on

t2=1:round(t_D_mean(1)*1000);
y2=fx_D_mean(1)*ones(1,length(t2));
for i=2:rn2
    t_temp1=length(t2);
    t_temp2=t_temp1+round(t_D_mean(i)*1000);
    t2=[t2,t_temp1+1:t_temp2];
    y2=[y2,fx_D_mean(i)*ones(1,round(t_D_mean(i)*1000))];
end
if(t2<t_limit)
    plot(t2/1000,y2,'g-','LineWidth',linewidth)
else
    plot(t2(1:t_limit)/1000,y2(1:t_limit),'g-','LineWidth',linewidth)
end

t3=1:round(t_BFS_mean(1)*1000);
y3=fx_BFS_mean(1)*ones(1,length(t3));
for i=2:rn3
    t_temp1=length(t3);
    t_temp2=t_temp1+round(t_BFS_mean(i)*1000);
    t3=[t3,t_temp1+1:t_temp2];
    y3=[y3,fx_BFS_mean(i)*ones(1,round(t_BFS_mean(i)*1000))];
end
if(t3<t_limit)
    plot(t3/1000,y3,'r-','LineWidth',linewidth)
else
    plot(t3(1:t_limit)/1000,y3(1:t_limit),'r-','LineWidth',linewidth)
end

legend('DWLLC','Dijkstra','BFS')